##############################################################################     
#      
# Zope Public License (ZPL) Version 0.9.7     
# ---------------------------------------     
#      
# Copyright (c) Digital Creations.  All rights reserved.     
#      
# This license has been certified as Open Source(tm).     
#      
# Redistribution and use in source and binary forms, with or without     
# modification, are permitted provided that the following conditions are     
# met:     
#      
# 1. Redistributions in source code must retain the above copyright     
#    notice, this list of conditions, and the following disclaimer.     
#      
# 2. Redistributions in binary form must reproduce the above copyright     
#    notice, this list of conditions, and the following disclaimer in     
#    the documentation and/or other materials provided with the     
#    distribution.     
#      
# 3. Digital Creations requests that attribution be given to Zope     
#    in any manner possible. Zope includes a "Powered by Zope"     
#    button that is installed by default. While it is not a license     
#    violation to remove this button, it is requested that the     
#    attribution remain. A significant investment has been put     
#    into Zope, and this effort will continue if the Zope community     
#    continues to grow. This is one way to assure that growth.     
#      
# 4. All advertising materials and documentation mentioning     
#    features derived from or use of this software must display     
#    the following acknowledgement:     
#      
#      "This product includes software developed by Digital Creations     
#      for use in the Z Object Publishing Environment     
#      (http://www.zope.org/)."     
#      
#    In the event that the product being advertised includes an     
#    intact Zope distribution (with copyright and license included)     
#    then this clause is waived.     
#      
# 5. Names associated with Zope or Digital Creations must not be used to     
#    endorse or promote products derived from this software without     
#    prior written permission from Digital Creations.     
#      
# 6. Modified redistributions of any form whatsoever must retain     
#    the following acknowledgment:     
#      
#      "This product includes software developed by Digital Creations     
#      for use in the Z Object Publishing Environment     
#      (http://www.zope.org/)."     
#      
#    Intact (re-)distributions of any official Zope release do not     
#    require an external acknowledgement.     
#      
# 7. Modifications are encouraged but must be packaged separately as     
#    patches to official Zope releases.  Distributions that do not     
#    clearly separate the patches from the original work must be clearly     
#    labeled as unofficial distributions.  Modifications which do not     
#    carry the name Zope may be packaged in any form, as long as they     
#    conform to all of the clauses above.     
#      
#      
# Disclaimer     
#      
#   THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY     
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE     
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR     
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS     
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,     
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT     
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF     
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND     
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,     
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT     
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF     
#   SUCH DAMAGE.     
#      
#      
# This software consists of contributions made by Digital Creations and     
# many individuals on behalf of Digital Creations.  Specific     
# attributions are listed in the accompanying credits file.     
#      
##############################################################################     
#      
# Portions Copyright (c) 1999 by Butch Landingin.     
#      
# Redistribution and use in source and binary forms, with or without     
# modification, are permitted provided that the following conditions     
# are met:     
# 1. Redistributions of source code must retain the above copyright     
#    including the original copyright, this copyright notice, the list of      
#    conditions and the following disclaimer.     
# 2. Redistributions in binary form must reproduce the above copyright     
#    including the original copyright, this copyright notice, the list of      
#    conditions and the following disclaimer in the     
#    documentation and/or other materials provided with the distribution.     
# 3. The name of the author may not be used to endorse or promote products     
#    derived from this software without specific prior written permission     
#     
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR     
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES     
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.     
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,     
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT     
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,     
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY     
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF     
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.     
#       
#  In accordance with the license provided for by the software upon     
#  which some of the source code has been derived or used, the following      
#  acknowledgement is hereby provided :     
#     
#      "This product includes software developed by Digital Creations     
#      for use in the Z Object Publishing Environment     
#      (http://www.zope.org/)."     
#      
##############################################################################     
     
__doc__ = """Squishdot - a web-based news publishing and discussion system"""
__version__='$Revision: 1.28 $'[11:-2]     
     
import sys, re    
from Globals import Persistent     
from Globals import PersistentMapping     
from Globals import HTMLFile, MessageDialog
import Globals
from OFS.ObjectManager import ObjectManager     
from AccessControl.Role import RoleManager     
from IOBTree import BTree     
from intSet import intSet     
from Squishfile import Squishfile     
from OFS.Folder import Folder    
from Acquisition import Implicit     
from time import time, localtime, strftime, gmtime     
from string import strip,split,join     
from string import lower,rfind,atoi, replace    
from urllib import quote, unquote     
from DocumentTemplate.DT_Util import html_quote    
from OFS.Document import Document
# ZCatalog imports
from Products.ZCatalog import ZCatalog
# Structured Text imports
import StructuredText

CRLF=re.compile('\r\n|\n\r')    
tagRegex = re.compile("<.*?>")     
    
class Stack:     
    def __init__(self):     
        self.mlist = []     
    def pop(self):     
        data = self.mlist[-1]     
        del self.mlist[-1]     
        return data     
    def push(self,data):     
        self.mlist.append(data)     
    def isEmpty(self):     
        return (len(self.mlist) == 0)     
     
def sameday(n, m):     
    n = localtime(n)     
    m = localtime(m)     
    if m[0] == n[0] and m[1] == n[1] and m[2] == n[2]:     
        return 1     
    else:     
        return 0     
     
def addDTML(obj,id,title,file):     
    f=open('%s/Products/%s.dtml' % (SOFTWARE_HOME,file))     
    file=f.read()     
    f.close()     
    obj.manage_addDTMLMethod(id,title,file)     
    return getattr(obj,id)     
     
def addImage(obj,id,file):     
    f=open('%s/Products/%s' % (SOFTWARE_HOME,file),'rb')     
       
    contents=f.read()     
    f.close()     
    title=''     
    tlen = len(contents)     
    new_id = obj.manage_addImage(id,contents,title=title)   
    img_obj = obj.__getitem__(new_id)  
    img_obj.content_type = 'image/gif'  
    
     
def addTable(obj,id,fname):     
    file=open('%s/Products/%s.tbl' % (SOFTWARE_HOME,fname))     
    cols=file.readline()     
    cols=cols[:-1] # takeout newline     
    delim=file.readline()     
    delim=delim[:-1]     
    fcontent=file.read()     
    file.close()     
    title=''     
    obj.manage_addTinyTable(id,title,delim,cols)     
    tbl=getattr(obj,id)     
    tbl.manage_editData(fcontent)     
     
def addNewTable(obj,id,fname):     
    file=open('%s/Products/%s.tbl' % (SOFTWARE_HOME,fname))     
    cols=file.readline()     
    cols=cols[:-1] # takeout newline     
    fcontent=file.read()     
    file.close()     
    title=''     
    obj.manage_addTinyTable(id,title,cols)     
    tbl=getattr(obj,id)     
    tbl.manage_editData(fcontent)     
     
def addArt(obj,file):     
    f=open('%s/Products/%s' % (SOFTWARE_HOME,file))     
    file=''     
    title = f.readline()[:-1] # removes newline char     
    subject = f.readline()[:-1]     
    author = f.readline()[:-1]     
    email = f.readline()[:-1]     
    notify= f.readline()[:-1]     
    dept=f.readline()[:-1]     
    summary=''     
    currline=f.readline()     
    while strip(currline) <> '%%' and currline <> '':     
        summary = summary + currline     
        currline=f.readline()     
    body=''     
    currline=f.readline()     
    while strip(currline) <> '%%' and currline <> '':     
        body = body + currline     
        currline=f.readline()     
    f.close()         
    id =  obj.addPosting(title,author,body,email,notify,file,summary,subject,dept,None,None,1)     
    msg = obj.data[id]     
    msg.reviewed = 1     
    return id     
     
PATH_SEP=re.compile('[\\/]')      
    
def addFile(file, ctype):     
    try:     
        f = open('%s/Products/%s' % (SOFTWARE_HOME,file),'rb')     
    except:     
        return ''     
    sf = Squishfile()     
    sf._file = f.read()     
    f.close()     
    name=strip(PATH_SEP.split(file)[-1])     
    sf._name = name     
    sf._ctype = ctype           
    sf._created = time()     
    sf._modified = sf._created     
    return sf     
    
htmlhead =  '''<html><head><title>%s</title>  
<body><pre>    
'''    
    
htmlend = '''   
</pre></body></html>    
'''    
    
def addText(file,title):    
    global htmlhead, htmlend     
    try:     
        f = open('%s/Products/%s' % (SOFTWARE_HOME,file),'rb')     
    except:     
        return htmlhead + htmlend         
    s = f.read()     
    f.close()     
    return (htmlhead % title) + html_quote(s) + htmlend    
    
readme = addText('Squishdot/README.txt','Readme')    
credits = addText('Squishdot/Credits.txt','Credits')    
license = addText('Squishdot/License.txt','License')    
changes = addText('Squishdot/Changes.txt','Changes')    
version = addText('Squishdot/version.txt','Version')
    
class SquishSite(ZCatalog.ZCatalog, RoleManager):     
    """A Squishdot Site is a self contained web-based news publishing and discussion system"""     
    meta_type  ='Squishdot Site'     
    description='Squishdot Site'     
     
    icon       ='misc_/Squishdot/squishdot_img'     
    root       =1     
    squishlogo ='misc_/Squishdot/squishlogo'    
    
    _properties=({'id':'title', 'type':'string','mode':'w'},)     
     
    # Default encoding for old postings
    encoding = 'HTML'

    # Defaults for old sites
    mail_articles=0
    mail_replies=0

    # protected by 'Manage Postings' permission
    manage_postings   = HTMLFile('Squishdot_manage_postings', globals())
    # protected by 'Manage Postings' permission
    manage_moderation = HTMLFile('Squishdot_manage_moderation', globals())
    # protected by 'Manage Postings' permission
    moderateArticle   = HTMLFile('moderateArticle',globals())
    # protected by 'Manage Squishdot' permission
    manage_editForm   = HTMLFile('Squishdot_editForm', globals())     
    # protected by 'Manage Squishdot' permission
    manage_subjects   = HTMLFile('Squishdot_manage_subjects', globals())    

    About = HTMLFile('about',globals())
    About.__roles__=None    
    
    Readme = Document(readme, __name__='Readme')    
    Readme.__roles__=None    

    Credits = Document(credits, __name__='Credits')    
    Credits.__roles__=None    

    License = Document(license, __name__='License')
    License.__roles__=None    
    
    Changes = Document(changes, __name__='Changes')
    Changes.__roles__=None    
    
    Version = Document(version, __name__='Version')
    Version.__roles__=None
       
    manage_options=({'label':'Contents', 'icon':icon, 'action':'manage_main', 'target':'manage_main'},     
                    {'label':'View', 'icon':'', 'action':'index_html', 'target':'manage_main'},     
                    {'label':'Postings', 'icon':'', 'action':'manage_postings', 'target':'manage_main'},     
                    {'label':'Moderation', 'icon':'', 'action':'manage_moderation', 'target':'manage_main'},
                    {'label':'Subjects', 'icon':'', 'action':'manage_subjects', 'target':'manage_main'},     
                    {'label':'Options', 'icon':'', 'action':'manage_editForm', 'target':'manage_main'},     
                    {'label':'Properties', 'icon':'', 'action':'manage_propertiesForm', 'target':'manage_main'},
                    {'label':'Security', 'icon':'', 'action':'manage_access', 'target':'manage_main'}
                    )     
     
    __ac_permissions__=Folder.__ac_permissions__+(     
        ('Manage Squishdot', ['add_subject','delete_subjects','manage_edit', 'updateIndexing','manage_main','manage',
                              'manage_editForm','manage_subjects','manage_propertiesForm','manage_editProperties','subject_count'], ('Manager',)),     
        ('Moderate Postings', ['manage_delete', 'manage_postings', 'recatalogPostings', 'manage_review', 'manage_moderation',
                               'moderateArticle','moderation_process','postingValues','item_count'], ('Manager',)),     
        ('Add Postings', ['addPosting','suggest_author','suggest_email','render'], ('Anonymous', 'Manager')),     
        ('View', ['search','index_html','dupString','striptags','has_subjects','subjects_list','subject_image','item_list',
                  'other_list','date_list','site_item_list','tpId','tpURL','this','site','site_url','has_items','desc_items',], ('Anonymous', 'Manager')),     
        )     
        
        
    # protected by 'Manage Squishdot' permission
    def updateIndexing(self,REQUEST=None):
        """ A a ZCatalog and appropriate indexes to this SquishSite if they aren't there already """
        if not hasattr(self,'_catalog'):
            ZCatalog.ZCatalog.__init__(self, self.id, self.title)
        try:
            self._catalog.addIndex('author', 'FieldIndex')
        except 'Index Exists':
            pass
        try:
            self._catalog.addIndex('textToSearch', 'TextIndex')
        except 'Index Exists':
            pass
        try:
            self._catalog.addIndex('subject', 'FieldIndex')
        except 'Index Exists':
            pass
        try:
            self._catalog.addIndex('reviewed', 'FieldIndex')
        except 'Index Exists':
            pass
        self.recatalogPostings(REQUEST)

    # protected by 'Manage Postings' permission
    def recatalogPostings(self,REQUEST=None):
        """ Clear the Catalog and then Index all the postings. """
        self._catalog.clear()
        for id in self.data.keys():
            obj = self.data[id]
            self.catalog_object(obj,join(self.getPhysicalPath(),'/')+obj.thread_path()+'/'+`id`)
        return self.manage_main(self, REQUEST)     
            

    # no permissions, only called from python
    def __init__(self, id, title, mhost, exp, moderated, max_itemlist, default_doc, mail_articles, mail_replies,parent):

        # Initialise ZCatalog
        ZCatalog.ZCatalog.__init__(self, id, title)
        
        t=time()     
        self.id       = id     
        self.title    = title     
        self.created  = t     
        self.modified = t     
        self.mail_host= mhost     
        self.expire   = exp
        self.mail_articles = mail_articles
        self.mail_replies = mail_replies
     
        self.moderated= 0     
        self.mod_comment = 0     
        if moderated == 'both':     
            self.moderated = 1     
            self.mod_comment= 1     
        else:     
            if moderated == 'articles':     
                self.moderated = 1     
                self.mod_comment=0     
     
        if max_itemlist:     
            self.max_itemlist=max_itemlist     
        else:     
            self.max_itemlist=30     

        # Set up the indexes
        # We get a 'title' TextIndex for free from ZCatalog.ZCatalog
	self._catalog.addIndex('author', 'FieldIndex')
	self._catalog.addIndex('textToSearch', 'TextIndex')
	self._catalog.addIndex('subject', 'FieldIndex')
	self._catalog.addIndex('reviewed', 'FieldIndex')

        self.data     =BTree()  # id -> Message     
        self.ids      =intSet() # ids of children
        
        self.subjects = PersistentMapping() # The List of subjects/categories   
     
        self.defaultDocFile('validateArticle','Validate Article',     
                            'Squishdot/validArticle')     
        self.defaultDocFile('validateComment','Validate Comment',     
                            'Squishdot/validComment')     
        self.defaultDocFile('rdf','Netscape RDF/RSS channel page',     
                            'Squishdot/Squishdot_rdf_rss')     
    
        newprop = list(self._properties)     
        newprop.append({'id':'rss_description', 'type': 'string', 'mode': 'w'})     
        newprop.append({'id':'rss_title', 'type': 'string', 'mode': 'w'})     
        newprop.append({'id':'rss_image_url', 'type': 'string', 'mode': 'w'})     
        newprop.append({'id':'admin_address', 'type': 'string', 'mode': 'w'})     
    
        if default_doc == 'plain':     
            self.defaultDocFile('showMessage','Show Message',     
                                'Squishdot/showMessage')     
            self.defaultDocFile('showError','Show Error',     
                                'Squishdot/showError')     
            self.defaultDocFile('mail_html','Notification Email',     
                                'Squishdot/Squishdot_mail_html')     
            self.defaultDocFile('index_html','Squishdot Homepage',     
                                'Squishdot/Squishdot_index_html')     
            self.defaultDocFile('posting_html','Posting',     
                                'Squishdot/Squishdot_posting_html')     
            self.defaultDocFile('searchForm','Search Form',     
                                'Squishdot/Squishdot_searchForm')     
            self.defaultDocFile('showSearchResults','Search Results',     
                                'Squishdot/Squishdot_searchResults')     
            self.defaultDocFile('addPostingForm','Add Posting Form',     
                                'Squishdot/addPostingForm')     
            self.defaultDocFile('previewPosting','Preview Posting',     
                                'Squishdot/Squishdot_previewForm')     
            self._properties = tuple(newprop)     
            self._updateProperty('rss_image_url','')      
            self._updateProperty('admin_address','squishdot@yahoo.com')     
     
        if default_doc == 'demo1' or default_doc == 'demo2':     
            self.defaultDocFile('showMessage','Show Message',     
                                'Squishdot/demo/showMessage')     
            self.defaultDocFile('showError','Show Error',     
                                'Squishdot/demo/showError')     
            load_tbls = 1     
            tblver=''     
            try:     
                # check if TinyTable product exists     
                file = 'TinyTable/About'     
                f=open('%s/Products/%s.dtml' % (SOFTWARE_HOME,file))     
                f.close()      
                #     
                file = 'TinyTable/version.txt'     
                f=open('%s/Products/%s' % (SOFTWARE_HOME,file))     
                tblver=f.readline()     
                f.close()     
                tblver=tblver[:-1] #takeout newline     
            except:     
                load_tbls = 0     
     
            self.defaultDocFile('mail_html','Notification Email',     
                                'Squishdot/demo/Squishdot_mail_html')     
            self.defaultDocFile('index_html','Squishdot Homepage',     
                                'Squishdot/demo/Squishdot_index_html')     
            self.defaultDocFile('posting_html','Posting',     
                                'Squishdot/demo/Squishdot_posting_html')     
            self.defaultDocFile('searchForm','Search Form',     
                                'Squishdot/demo/Squishdot_searchForm')     
            self.defaultDocFile('showSearchResults','Search Results',     
                                'Squishdot/demo/Squishdot_searchResults')     
            self.defaultDocFile('addPostingForm','Add Posting Form',     
                                'Squishdot/demo/addPostingForm')     
      
            self.defaultDocFile('site_footer','Site Footer',     
                                'Squishdot/demo/site_footer')     
            self.defaultDocFile('site_header','Site Header',     
                                'Squishdot/demo/site_header')     
            self.defaultDocFile('previewPosting','Preview Posting',     
                                'Squishdot/demo/Squishdot_previewForm')     
     
            self.manage_addFolder('Images','Images')     
            self.manage_addFolder('TopicImages','Topic Images')     
            self.manage_addFolder('misc_methods','Misc. methods')     
            self.manage_addFolder('rightbox_methods','Right box methods')     
     
            curr_folder =  getattr(self,'misc_methods')     
            addDTML(curr_folder,'advertising','advertising','Squishdot/demo/misc_methods/advertising')     
            addDTML(curr_folder,'copyright_notice','copyright','Squishdot/demo/misc_methods/copyright')     
            addDTML(curr_folder,'quotation','quotation','Squishdot/demo/misc_methods/quotation')     
     
            curr_folder =  getattr(self,'rightbox_methods')     
            feat_method = addDTML(curr_folder,'features','Features','Squishdot/demo/rightbox_methods/features')     
            prev_method = addDTML(curr_folder,'prev_articles','Previous Articles','Squishdot/demo/rightbox_methods/prevarticles')     
            quik_method = addDTML(curr_folder,'quick_links','Quick Links','Squishdot/demo/rightbox_methods/quicklinks')     
            rfc_method = addDTML(curr_folder,'request_comments','Requests for Comments','Squishdot/demo/rightbox_methods/reqcomments')     
            rev_method = addDTML(curr_folder,'reviews','Reviews','Squishdot/demo/rightbox_methods/reviews')     
     
            curr_folder =  getattr(self,'Images')     
            addImage(curr_folder,'botshadow_img','Squishdot/demo/Images/botshadow.gif')     
            addImage(curr_folder,'roundedge_img','Squishdot/demo/Images/roundedge.gif')     
            addImage(curr_folder,'rtbotshadow_img','Squishdot/demo/Images/rtbotshadow.gif')     
            addImage(curr_folder,'rtshadow_img','Squishdot/demo/Images/rtshadow.gif')     
            addImage(curr_folder,'sitetitle_img','Squishdot/demo/Images/sitetitle.gif')     
            addImage(curr_folder,'bluepix_img','Squishdot/demo/Images/bluepix.gif')     
            addImage(curr_folder,'greenpix_img','Squishdot/demo/Images/greenpix.gif')     
            addImage(curr_folder,'advert_img','Squishdot/demo/Images/advert.gif')     
     
            curr_folder =  getattr(self,'TopicImages')     
            # note: build images      
            addImage(curr_folder,'dc_img',  'Squishdot/demo/TopicImages/dc.gif')     
            addImage(curr_folder,'zope_img','Squishdot/demo/TopicImages/zope.gif')     
            addImage(curr_folder,'dtml_img','Squishdot/demo/TopicImages/dtml.gif')     
            addImage(curr_folder,'help_img','Squishdot/demo/TopicImages/help.gif')     
            addImage(curr_folder,'squishdot_img','Squishdot/demo/TopicImages/squish.gif')     
            addImage(curr_folder,'zopedev_img','Squishdot/demo/TopicImages/zopedev.gif')     
            addImage(curr_folder,'zdp_img','Squishdot/demo/TopicImages/zdp.gif')     
            addImage(curr_folder,'zserver_img','Squishdot/demo/TopicImages/zserver.gif')     
            addImage(curr_folder,'dope_img','Squishdot/demo/TopicImages/dope.gif')     
     
            if load_tbls and tblver:                     
                if tblver[10:] > '0-8-0':     
                    addNewTable(self,'bottom_items','Squishdot/demo/newtables/bottom_items')     
                    addNewTable(self,'leftbox_items','Squishdot/demo/newtables/leftbox_items')     
                    addNewTable(self,'rightbox_items','Squishdot/demo/newtables/rightbox_items')     
                else:     
                    addTable(self,'bottom_items','Squishdot/demo/bottom_items')     
                    addTable(self,'leftbox_items','Squishdot/demo/leftbox_items')     
                    addTable(self,'rightbox_items','Squishdot/demo/rightbox_items')     
     
            newprop.append({'id':'color1', 'type': 'string', 'mode': 'w'})     
            newprop.append({'id':'color2', 'type': 'string', 'mode': 'w'})     
            newprop.append({'id':'color3', 'type': 'string', 'mode': 'w'})     
            newprop.append({'id':'linedot_image', 'type': 'string', 'mode': 'w'})     
            newprop.append({'id':'color4', 'type': 'string', 'mode': 'w'})     
            newprop.append({'id':'color5', 'type': 'string', 'mode': 'w'})     
            newprop.append({'id':'drop_shadow', 'type': 'int', 'mode': 'w'})     
            newprop.append({'id':'round_edge', 'type': 'int', 'mode': 'w'})     
            newprop.append({'id':'title_image', 'type': 'string', 'mode': 'w'})     
            newprop.append({'id':'site_name', 'type': 'string', 'mode': 'w'})     
            newprop.append({'id':'comment_spillover', 'type': 'int', 'mode': 'w'})     
            newprop.append({'id':'prevday_cnt', 'type': 'int', 'mode': 'w'})     
            newprop.append({'id':'admin_name', 'type': 'string', 'mode': 'w'})     
            self._properties = tuple(newprop)     
            self._updateProperty('color1','#000000')      
            self._updateProperty('color2','#ffffff')      
            if default_doc == 'demo1':     
                self._updateProperty('color3','#006666')      
                self._updateProperty('linedot_image','Images/greenpix_img')      
            else:     
                self._updateProperty('color3','#0066cc')      
                self._updateProperty('linedot_image','Images/bluepix_img')      
            self._updateProperty('color4','#cccccc')      
            self._updateProperty('color5','#333333')      
            self._updateProperty('drop_shadow',1)      
            self._updateProperty('round_edge',1)      
            self._updateProperty('title_image','Images/sitetitle_img')      
            self._updateProperty('site_name','Squishdot')      
            self._updateProperty('comment_spillover',10)      
            self._updateProperty('prevday_cnt',7)      
            self._updateProperty('admin_address','squishdot@yahoo.com')     
            self._updateProperty('admin_name','the ZopeMeister')     
            self._updateProperty('rss_image_url','Images/sitetitle_img')      
     
            self.add_subject('Zope','TopicImages/zope_img')     
            self.add_subject('Zope DTML','TopicImages/dtml_img')     
            self.add_subject('Help','TopicImages/help_img')     
            self.add_subject('Digital Creations','TopicImages/dc_img')     
            self.add_subject('Squishdot','TopicImages/squishdot_img')     
            self.add_subject('Zope Development','TopicImages/zopedev_img')     
            self.add_subject('Zope Doc Project','TopicImages/zdp_img')     
            self.add_subject('ZServer','TopicImages/zserver_img')     
            self.add_subject('Zope Dopes','TopicImages/dope_img')     
     
     
            wrapped=self.__of__(parent)
            id10 = addArt(wrapped,'Squishdot/demo/messages/message10.txt')     
            id9 = addArt(wrapped,'Squishdot/demo/messages/message9.txt')     
            id8 = addArt(wrapped,'Squishdot/demo/messages/message8.txt')     
            id7 = addArt(wrapped,'Squishdot/demo/messages/message7.txt')     
            id6 = addArt(wrapped,'Squishdot/demo/messages/message6.txt')     
            id5 = addArt(wrapped,'Squishdot/demo/messages/message5.txt')     
            id4 = addArt(wrapped,'Squishdot/demo/messages/message4.txt')     
            id3 = addArt(wrapped,'Squishdot/demo/messages/message3.txt')     
            id2 = addArt(wrapped,'Squishdot/demo/messages/message2.txt')     
            id1 = addArt(wrapped,'Squishdot/demo/messages/message1.txt')     
            raw = feat_method.raw % (str(id1),str(id2),str(id5))     
            feat_method.raw = raw     
            raw = rfc_method.raw % str(id3)     
            rfc_method.raw = raw     
            art8 = self.data[id8]     
            file8 = addFile('Squishdot/demo/messages/images.zip','application/x-zip-compressed')     
            if file8:     
                setattr(art8,file8._name,file8)     
                art8.file=file8     
            else:     
                art8.file=''     
    
        #set rss related properties          
        self._updateProperty('rss_description','Squishdot: Cool Dope on Zope')      
        self._updateProperty('rss_title',title)      
    
    def __len__(self): return 1     
     
    def __getitem__(self,n):     
        try:    id=atoi(n)     
        except: raise AttributeError, n     
        if self.ids.has_key(id):     
            return self.data[id].__of__(self)     
        raise AttributeError, n     
     
    # protected by 'View' permission
    def dupString(self, dstr, count):     
        # ''' returns a duplicate of dstr by count times'''     
        return dstr * count     
    
    # protected by 'View' permission
    def striptags(self,s):    
        # ''' removes char sequences that invalidate RSS syntax'''     
        return tagRegex.sub("",s)    
    
     
    # protected by 'View' permission
    def has_subjects(self):     
        # ''' returns true if site has subject topics defined'''     
        return len(self.subjects)     
     
    # protected by 'Manage Squishdot' permission
    def subject_count(self):     
        # ''' gives count of subject topics defined'''     
        return self.has_subjects()     
     
    # protected by 'Manage Squishdot' permission
    def add_subject(self,subject='', imgurl='', REQUEST=None,RESPONSE=None):     
        """ add a subject topic """     
        if subject is None:     
            return MessageDialog(title='Data Missing',     
                                 message='You must enter a subject!',     
                                 action=REQUEST['URL1']+'/manage_subjects',     
                                 target='manage_main'     
                                )     
        self.subjects[subject]= imgurl     
        self._p_changed = 1    
     
        if REQUEST:     
            return self.manage_subjects(self, REQUEST)     
     
    # protected by 'Manage Squishdot' permission
    def delete_subjects(self,subjs=[],REQUEST=None):     
        """ delete a subject topic"""     
        for subj in subjs:     
            del self.subjects[subj]     
        self._p_changed = 1    
        if REQUEST:     
            return self.manage_subjects(self, REQUEST)     
     
    # protected by 'View' permission
    def subjects_list(self):     
        # ''' lists all subjects '''    
        subjects = self.subjects.keys()    
        subjects.sort()    
        return subjects    
     
    # protected by 'View' permission
    def subject_image(self,subj):     
        # ''' returns an image url associated with the subject (can be an empty string)'''     
        if self.subjects.has_key(subj):     
            return self.subjects[subj]     
        else:     
            return ''     

    setItem__roles__=[]
    def setItem(self,id,obj):     
        # Make sure the object we store is not wrapped with     
        # an acquisition wrapper, since we will be wrapping     
        # it again manually in __getitem__ when it is needed.     
        if hasattr(obj, 'aq_base'):     
            obj=obj.aq_base     
        self.ids.insert(id)     
        self.data[id]=obj

        # No thread_path is needed here as objects are all being added to the SquishSite object.
        self.catalog_object(obj,join(self.getPhysicalPath(),'/')+'/'+`id`)
     
    delitem__roles__=[]
    def delItem(self,id):     
        data=self.data     
        item=data[id]     
        if self.ids.has_key(id): self.ids.remove(id)     
        else: data[item.thread[-1]].ids.remove(id)     
        if self.moderated:     
            if item.meta_type == 'Article':     
                if not item.reviewed:     
                    for t in item.thread:     
                        obj=self.data[t]     
                        if obj.revsub > 0: obj.revsub=obj.revsub-1     
                else:     
                    for t in item.thread:     
                        obj=self.data[t]     
                        if obj.reply_cnt > 0: obj.reply_cnt = obj.reply_cnt-1     
            else:     
                if self.mod_comment:     
                    if not item.reviewed:     
                        for t in item.thread:     
                            obj=self.data[t]     
                            if obj.revsub > 0: obj.revsub=obj.revsub-1     
                    else:     
                        for t in item.thread:     
                            obj=self.data[t]     
                            if obj.reply_cnt > 0: obj.reply_cnt = obj.reply_cnt-1     
                else:     
                    for t in item.thread:     
                        obj=self.data[t]     
                        if obj.reply_cnt > 0: obj.reply_cnt = obj.reply_cnt-1     
     
        else:     
            for t in item.thread:     
                obj=self.data[t]     
                if obj.reply_cnt > 0: obj.reply_cnt = obj.reply_cnt-1     
        ids=intSet()     
        ids.insert(id)     
        ids=item.sub_ids(ids,data)     
        item=None
        
        
        # Un-catalog the objects to be deleted.
        for id in ids:     
            obj = data[id]
            self.uncatalog_object(join(self.getPhysicalPath(),'/')+obj.thread_path()+'/'+`id`)

        for id in ids:     
            del data[id]     
     
    createId__roles__=[]
    def createId(self):     
        id=int(time())     
        while 1:     
            try:    o=self.data[id]     
            except: break     
            id=id+1     
        return id     
     
    defaultDocFile__roles__=[]
    def defaultDocFile(self,id,title,file):     
        f=open('%s/Products/%s.dtml' % (SOFTWARE_HOME,file))     
        file=f.read()     
        f.close()     
        self.manage_addDTMLMethod(id,title,file)     
     
    # protected by 'Manage Postings' permission
    def postingValues(self):     
        # """ return list of articles """     
        return map(lambda x, p=self: x.__of__(p), self.data.map(self.ids))     
     
    rev_id_list__roles__=[]
    def rev_id_list(self):     
        # """ returns reversed id list of reviewed articles  """     
        rlist = map(None,self.ids)     
        rlist = filter(lambda x,p=self : p.data[x].reviewed, rlist)     
        rlist.reverse()     
        return rlist     
     
    # protected by 'View' permission
    def item_list(self):     
        # """ returns latest articles  """                          
        currtime =   int(time())     
        return map(lambda x, p=self: x.__of__(p), self.data.map(self.id_list(currtime)))     
     
    id_list__roles__=[]
    def id_list(self, currtime):     
        # ''' returns id list of latest articles at currtime '''     
        rlist = self.rev_id_list()     
        max = self.max_itemlist     
        min = max / 3     
        rlen = len(rlist)     
        if rlen <= min:     
            pass # take all elements     
        else:     
            today_list = self.date_id_list(currtime)  # take only items from today     
            tlen = len(today_list)     
            if tlen <= min:     
                rlist = rlist[:min] # take minimum elements even though some items came from yesterday     
            else:     
                if tlen >= max:     
                    rlist = today_list[:max]  # take maximum elements from today                        
                else:     
                    rlist = today_list # take entire list of items from today     
        return rlist     
             
    other_id_list__roles__=[]
    def other_id_list(self, currtime):     
        # '''returns id list of articles exceeding max but still within current day'''      
        today_list = self.date_id_list(currtime) # take only items from today     
        tlen = len(today_list)     
        curr_list = self.id_list(currtime)  # take items displayed on main page     
        clen = len(curr_list)     
        if tlen > clen:     
            return today_list[clen:]  # return items from today not displayed on main page     
        else:     
            return []     
     
    # protected by 'View' permission
    def other_list(self):     
        # """returns articles exceeding max but still within current day"""     
        currtime =   int(time())     
        return map(lambda x,  p=self: x.__of__(p), self.data.map(self.other_id_list(currtime)))     
     
    date_id_list__roles__=[]
    def date_id_list(self, currtime):     
        # """returns list from sameday """     
        rlist = self.rev_id_list()     
        return filter(lambda x,p=currtime: sameday(x,p), rlist)     
             
    # protected by 'View' permission
    def date_list(self, day=0):     
        # """return list from day """     
        currtime = int(time())  - (86400 * day)     
        return map(lambda x,  p=self: x.__of__(p), self.data.map(self.date_id_list(currtime)))     
     
    site_id_list__roles__=[]
    def site_id_list(self, currtime):     
        # """ returns latest id list from currtime  """     
        ilist = self.id_list(currtime)     
        tdict = {}     
        tlist = []     
        ilen = len(ilist)     
        cnt = 0      
        while (cnt < ilen) and (len(tdict) < 5):     
            id = ilist[cnt]     
            item = self.data[id]     
            if tdict.has_key(item.subject):     
                pass     
            else:     
                tdict[item.subject] = id     
                tlist.append(id)     
            cnt = cnt + 1     
     
        return tlist     
     
    # protected by 'View' permission
    def site_item_list(self):     
        # """ returns latest articles from today """     
        currtime =   int(time())     
        return map(lambda x, p=self: x.__of__(p), self.data.map(self.site_id_list(currtime)))     
            
     
    # protected by 'View' permission
    def tpId(self):     
        return self.id     
     
    # protected by 'View' permission
    def tpURL(self):     
        return self.id     
     
    # protected by 'View' permission
    def this(self):     
        return self     
     
    # protected by 'View' permission
    def site(self):     
        return (self,)     
     
    # protected by 'View' permission
    def site_url(self):    
        # """ url of the Squishdot main page """ 
        return self.absolute_url()
     
    # protected by 'View' permission
    def has_items(self):     
        return len(self.ids)     
     
    # protected by 'Moderate Postings' permission
    def item_count(self):     
        return len(self.data)     
     
    # I _think_ this is protected by the 'Add Squishdot Sites' permission
    def mailhost_list(self):
        #  """ list of mail hosts """
         try:    return self.superValues(('Mail Host',))     
         except: return []     
     
    # protected by 'View' permission
    def desc_items(self):     
        # """ articles in descending order """     
        mlist = []     
        mstack = Stack()     
        if self.has_items():     
            plist = []     
            for id in self.ids:     
                plist.append(id)     
            plist.reverse()     
            for id in plist:     
                mstack.push(id)     
            while not mstack.isEmpty():     
                item_id = mstack.pop()     
                item = self.data[item_id]     
                mlist.append(item)     
                if item.has_items():     
                    plist = []     
                    for id in item.ids:     
                        plist.append(id)     
                    plist.reverse()     
                    for id in plist:     
                        mstack.push(id)     
                        
        return map((lambda x, p=self: x.__of__(p)), mlist)     
           
    expire_items__roles__=[]
    def expire_items(self):     
        # """ run to delete articles which are past their expiration (assuming that it has been set)"""     
        if self.expire:     
            d=self.data     
            t=int(time()-(self.expire * 86400.0))     
            ids=[]     
            for id in d.keys():     
                if d[id].modified < t:     
                    ids.append(id)     
            for id in ids:     
                try:    self.delItem(id)     
                except: pass     
        return ''     
     
    # protected by 'Add Postings' permission
    def addPosting(self,title,author,body,email='',notify='',file='',     
                   summary='',subject='',dept='',REQUEST=None,RESPONSE=None,internal=0,encoding='HTML'):     
        """ add an article """     
        title =strip(title)     
        author=strip(author)     
        email =strip(email)     
        summary = strip(summary)     
        if summary:     
            summary  =split(CRLF.sub('\n',summary),'\n')     
        else:     
            summary = None     
        subject =strip(subject)     
        dept =strip(dept)     
        body = strip(body)     
        if body:     
            body  =split(CRLF.sub('\n',body),'\n')     
        else:     
            body = None     
        notify=notify             
        reviewed=(not self.moderated) and 1 or 0     
    
        if not internal:     
            message=self.validateArticle(REQUEST=REQUEST,title=title,author=author,    
                                        email=email,summary=summary,dept=dept,body=body,notify=notify,encoding=encoding)     
            if message:     
                return self.showError(self, REQUEST=REQUEST,title='Data Missing',     
                                      message=message,     
                                      action=REQUEST['URL1']+'/previewPosting'     
                                     )     
     
        try:    file=Squishfile(file)     
        except: file=''     
     
        id=self.createId()     
        msg=Article(id,intSet(),title,author,body,email,notify,reviewed,file,subject,dept,summary,encoding)     
        msg=msg.__of__(self)
        self.setItem(id,msg)
        self.expire_items()     
        
        if REQUEST:
            if self.mail_articles:
                self.sendEmail(msg,self.admin_address,REQUEST)
            sn = REQUEST['SCRIPT_NAME']     
            pi = REQUEST['PATH_INFO']     
            t=self.id     
            gtime = gmtime(id)     
            glist = list(gtime)     
            glist[0] = glist[0] + 1 # add 1 year to expiry date     
            glist[1] = 12     
            glist[2] = 31     
            glist[3] = 23     
            glist[4] = 59     
            glist[5] = 59     
            glist[6] = 0     
            glist[7] = 365     
            glist[8] = 0     
            gtime = tuple(glist)     
            e = strftime('%A, %d-%b-%y %H:%M:%S GMT',gtime)     
            resp=REQUEST['RESPONSE']     
            author = quote(author)    
            resp.setCookie('_suggest_author',author,expires=e,path='/')     
            email = quote(email)    
            resp.setCookie('_suggest_email',email,expires=e,path='/')     
            resp.setCookie('suggest_notify',notify,expires=e,path='/')     
            if self.moderated:     
                p2 = "%s/index_html" % self.absolute_url()     
            else:     
                p2 = "%s/%s/index_html" % (self.absolute_url(),id)     
            return self.showMessage(self, REQUEST=REQUEST, title='Article Posted',     
                                 message='Your article has been posted',     
                                 action=p2     
                                )     
        if internal:     
            return id     
     
    # protected by 'View' permission
    def search(self,REQUEST):     
        """ fulfill a search request """
        # Massage REQUEST so old form works with new searching...        
        
        if REQUEST.has_key('body') and REQUEST['body']:
            REQUEST.set('textToSearch',REQUEST['body'])
        if REQUEST.has_key('op') and REQUEST['op']=='articles':
            REQUEST.set('meta_type','Article')
        REQUEST.set('reviewed',1)
    
        sr=self.__call__(REQUEST,1)     
        rc=len(sr)     
        return self.showSearchResults(self,REQUEST,search_results=sr,     
                                  result_count=rc)     
     
     
    # protected by 'Manage Squishdot' permission
    def manage_edit(self,mailhost='',exp=0,expire='0',moderated='none', max_itemlist=30,     
                    REQUEST=None, mail_articles=0, mail_replies=0):     
        """ edit SquishDot options  """     
        if exp: expire=atoi(expire)     
        else:   expire=0     
        if mailhost:     
            try:    v=getattr(self, mailhost)     
            except:      
                return MessageDialog(title='Invalid Mail Host',     
                                     message='Cannot find the named mail host!',     
                                     action=REQUEST['URL']+'/manage_main'     
                                    )     
        self.mail_host=mailhost     
        self.expire   =expire
        self.mail_articles = mail_articles
        self.mail_replies = mail_replies
     
        if moderated == 'both':     
            self.moderated = 1     
            self.mod_comment= 1     
        else:     
            if moderated == 'articles':     
                self.moderated = 1     
                self.mod_comment=0     
            else:     
                if moderated == 'none':     
                    self.moderated = 0     
                    self.mod_comment = 0     
     
        if max_itemlist:     
            self.max_itemlist=max_itemlist     
        else:     
            self.max_itemlist=30     
        return self.manage_main(self, REQUEST)     
     
    # protected by 'Moderate Postings' permission
    def manage_delete(self,ids=[],REQUEST=None):     
        """ delete selected articles from a Squishdot site """     
        ids=map(atoi, ids)     
        for id in ids:     
            self.delItem(id)
        if REQUEST is not None:
            return self.manage_postings(self, REQUEST, management_view='Postings')
        
    # protected by 'Moderate Postings' permission
    def manage_review(self,ids=[],REQUEST=None):     
        """ approve selected articles from a Squishdot site """     
        ids=map(atoi, ids)
        for id in ids:
            self.set_reviewed(self.data[id])
        if REQUEST is not None:
            return self.manage_postings(self, REQUEST, management_view='Postings')     

    # protected by 'Moderate Postings' permission
    def moderation_process(self, approve=None, delete=None, REQUEST=None):
        """ do the processing for things from the moderation tab """
        if approve:
            self.manage_review(REQUEST['approve'],REQUEST)
        if delete:
            self.manage_delete(REQUEST['delete'],REQUEST)
        if REQUEST is not None:
            return self.manage_main(self, REQUEST)

    # protected by 'Add Postings' permission
    def suggest_author(self):    
        author = ''    
        try: author = self.REQUEST.cookies['_suggest_author']    
        except: pass    
        if author : author = unquote(author)    
        return author or None    
    
    # protected by 'Add Postings' permission
    def suggest_email (self):    
        email  = ''    
        try: email  = self.REQUEST.cookies['_suggest_email']    
        except: pass    
        if email  : email  = unquote(email)    
        return email  or None    
                    
    # Used for Bruce Perens' Batch Moderation Code
    # Indicate that posting has been reviewed
    set_reviewed__roles__=[]
    def set_reviewed(self, item):
        item.reviewed=1
        for t in item.thread:
            obj=self.data[t]
            if obj.revsub > 0: obj.revsub=obj.revsub-1
            obj.reply_cnt = obj.reply_cnt+1

    # Searchable interface     
    def __call__(self, REQUEST=None, internal=0, **kw):
	brains = apply(self.searchResults,(REQUEST,),kw)
	objects = map(lambda x,self=self,r=REQUEST:
                      self.getobject(x.data_record_id_, r),
		      brains)
	if internal:
	    return objects
	return brains

    # This renders the raw document text into stuff that can be displayed with a dtml-var
    # When the following proposal happens, this method will become overridable:
    # http://dev.zope.org/Wikis/DevSite/Proposals/ReplaceableProperty
    
    # protected by 'Add Postings' permission
    def render(self,storedLines,format):
        if not storedLines:
            return ''
        if   format=='Plain':
            return join(map(html_quote,storedLines),'<BR>\n')
        elif format=='HTML':
            return join(storedLines,'\n')
        elif format=='STX':
            return str(StructuredText.html_with_references(replace(join(storedLines,'\n'),'\r',''), level=3))
        return 'Invalid Format!'
        
    sendEmail__roles__=[]
    def sendEmail(self,msg,address,REQUEST):
        # sends an email to the address using the mailhost, if there is one
        if self.mail_host:
            # reluctantly using try here as a failed notification shouldn't cause a Zope error on a site.
            try:
                mail =self.mail_html(self, REQUEST, newItem=(msg,), email=address)
                mhost=getattr(self,self.mail_host)
                mhost.send(mail)
            except:
                pass
            
Globals.default__class_init__(SquishSite)

class Posting(Persistent, Implicit,RoleManager):     
    """Squishdot Posting"""
    
    __allow_access_to_unprotected_subobjects__=1
    
    __ac_permissions__ = (
        ('Moderate Postings', ['manage_edit', 'manage_editForm','manage_main','manage','postingValues'], ('Manager',)),
        ('Add Postings', ['suggest_title','addPosting'], ('Anonymous', 'Manager')),     
        ('View', ['date_posted','body_len','date_created','time_created','attachment','thread_path','index_html','showBody',
                  'desc_items','dupString','striptags','tpId','tpURL','this','has_items','thread','title','author','body',
                  'email','subject','getThread'], ('Anonymous', 'Manager')),
        )

    # protected by 'Moderate Postings' permission
    manage_editForm=HTMLFile('editPostingForm', globals())
    
    # protected by 'Moderate Postings' permission
    manage         =manage_editForm     

    # protected by 'Moderate Postings' permission
    manage_main    =manage_editForm
    
    meta_type='Posting'     
    icon   ='misc_/Squishdot/posting_img'     
    root=0
    # Default encoding for old postings
    encoding = 'HTML'
    
    def __init__(self, id, thread, title, author, body,     
                 email, notify, reviewed, file, subject,level, encoding='HTML'):     
        self.id      =str(id)     
        self.ids     =intSet()     
        self.thread  =thread
        self.title   =title     
        self.author  =author     
        self.body    =body     
        self.email   =email     
        self.notify  =notify     
        self.created =id     
        self.modified=id     
        self.reviewed=reviewed     
        self.subject =subject     
        self.level =level
        self.encoding = encoding
        if file:     
            setattr(self,file._name,file)     
            self.file=file     
        else:     
            self.file=''     
        self.revsub  =0     
        self.reply_cnt =0     
     
    def getThread(self, index):
        """A better abstaction rather than accessing the list directly"""
        return self.thread[index]

    def __len__(self): return 1     
     
    def __getitem__(self,n):     
        try:    id=atoi(n)     
        except: raise AttributeError, n     
        if self.ids.has_key(id):     
            return self.data[id].__of__(self)     
        raise AttributeError, n     
     
    setItem__roles__=[]
    def setItem(self,id,obj):     
        # Make sure the object we store is not wrapped with     
        # an acquisition wrapper, since we will be wrapping     
        # it again manually in __getitem__ when it is needed.     
        if hasattr(obj, 'aq_base'):     
            obj=obj.aq_base     
     
        self.ids.insert(id)     
        self.data[id]=obj
        
        self.catalog_object(obj,join(self.getPhysicalPath(),'/')+obj.thread_path()+'/'+`id`)
     
    textToSearch__roles__=[]
    def textToSearch(self):
        # returns the text to search for a ZCatalog
        text=''
        for line in self.body:
            # strip out HTML and append a newline to each line.
            text = text+tagRegex.sub("",line)+'\n'
        return text

    # protected by 'View' permission
    def dupString(self, dstr, count):     
        return dstr * count     
    
    # protected by 'View' permission
    def striptags(self,s):    
        # ''' removes char sequences that invalidate RSS syntax (should really be a util function)'''     
        return tagRegex.sub("",s)    
    
    # protected by 'View' permission
    def date_posted(self,fmstr='%A %B %d, @%I:%M%p'):     
        # """ date when article was posted """     
        ltime = localtime(self.created)         
        return strftime(fmstr,ltime)     
             
    # protected by 'View' permission
    def body_len(self,divisor=None):     
        # """ total body length of text """    
        tlen = 0     
        if not self.body:     
            tlen = 0    
        else:    
            for line in self.body:     
                tlen = tlen + len(line)    
    
        if divisor is None:    
            if tlen == 0:    
                return ''    
            if tlen > 51200:     
                tlen = tlen / 1024     
                return str(tlen) + ' Kb'     
            else:     
                return str(tlen) + ' bytes'     
    
        if divisor < 1:    
            return tlen    
        else:    
            return tlen/divisor    
                    
    # protected by 'Manage Postings' permission
    def postingValues(self):     
        # """ return all replies """     
        return map(lambda x, p=self: x.__of__(p), self.data.map(self.ids))     
     
    # protected by 'View' permission
    def tpId(self):     
        return self.id     
     
    # protected by 'View' permission
    def tpURL(self):     
        return self.id     
     
    # protected by 'View' permission
    def this(self): return self     
         
    # protected by 'View' permission
    def has_items(self):     
        return len(self.ids)     
     
    sub_ids__roles__=[]
    def sub_ids(self,ids,data):     
        map(ids.insert, self.ids)     
        for item in data.map(self.ids):     
            ids=item.sub_ids(ids,data)     
        return ids     
     
    # protected by 'View' permission
    def desc_items(self):     
        # """ return latest list of replies """     
        mlist = []     
        mstack = Stack()     
        if self.has_items():     
            plist = []     
            for id in self.ids:     
                plist.append(id)     
            plist.reverse()     
            for id in plist:     
                mstack.push(id)     
            while not mstack.isEmpty():     
                item_id = mstack.pop()     
                item = self.data[item_id]     
                mlist.append(item)     
                if item.has_items():     
                    plist = []     
                    for id in item.ids:     
                        plist.append(id)     
                    plist.reverse()     
                    for id in plist:     
                        mstack.push(id)     
        return map((lambda x, p=self: x.__of__(p)), mlist)     
     
    # protected by 'View' permission
    def date_created(self):     
        # """ date article was created """     
        t=localtime(self.created)     
        return '%d/%d/%d' % (t[1],t[2],t[0])     
     
    # protected by 'View' permission
    def time_created(self):     
        # """ time article was created """     
        t=localtime(self.created)     
        return '%02d:%02d' % (t[3],t[4])     
     
    # protected by 'View' permission
    def attachment(self):     
        # """ file attachment """     
        file=self.file
        return file and (file,) or None     
     
    # protected by 'Add Postings' permission
    def suggest_title(self):     
        # """ suggested title of reply """     
        t=self.title     
        return (lower(t[:3])=='re:') and t or 'Re: %s' % t     
     
    # protected by 'View' permission
    def thread_path(self):     
        return join(map(lambda x: '/%s' % x, self.thread), '')     
     
    # protected by 'View' permission
    def index_html(self,REQUEST):     
        """ squishdot article main page (the read more page) """    
        return self.posting_html(self,REQUEST)     
     
    doNotify__roles__=[]
    def doNotify(self, msg, REQUEST):     
        # """ sends mail to notify person being replied to """     
        if self.notify and self.email:
            self.sendEmail(msg,self.email,REQUEST)

    cancelNotify__roles__=None
    def cancelNotify(self, REQUEST):     
        """ cancels email notification of replies """     
        self.notify=''     
        return self.showMessage(self, REQUEST=REQUEST, title='Cancelled Notification',     
                             message='You will no longer be notified of replies to this message',     
                             action=self.absolute_url()     
                            )     
     
    # protected by 'Add Postings' permission
    def addPosting(self,title,author,body,email='',notify='',file='',     
                   REQUEST=None,RESPONSE=None,encoding='HTML'):     
        """ add a reply """     
        title   =strip(title)     
        author  =strip(author)     
        email   =strip(email)     
        body    =strip(body)     
        notify  =notify     
        reviewed=(not self.mod_comment) and 1 or 0     
     
        message=self.validateComment(REQUEST=REQUEST,title=title,author=author,    
                                     email=email,body=body,notify=notify,encoding=encoding)    
     
        if message:    
            return self.showError(self, REQUEST=REQUEST,title='Data Missing',     
                                 message=message,     
                                 action=REQUEST['URL1'] + '/previewPosting'     
                                )     
        if body:     
            body = split(CRLF.sub('\n',body),'\n')     
        else:     
            body = None     
      
        try:    file=Squishfile(file)     
        except: file=''     
     
        id=self.createId()     
        thread=intSet()     
        map(thread.insert, self.thread)     
        thread.insert(atoi(self.id))     
        for t in thread:     
            obj=self.data[t]     
            obj.modified=id     
            if not reviewed:     
                obj.revsub=obj.revsub+1     
            else:     
                obj.reply_cnt = obj.reply_cnt+1     
     
        msg=Comment(id, thread, title, author, body, email, notify,     
                  reviewed, file, self.subject, self.level+1,encoding=encoding)     
        msg=msg.__of__(self)    
        self.setItem(id, msg)     
     
        if REQUEST:     
            self.doNotify(msg,REQUEST)
            
            if self.mail_replies:
                self.sendEmail(msg,self.admin_address,REQUEST)

            t=self.site()[0].id     
            gtime = gmtime(id)     
            glist = list(gtime)     
            glist[0] = glist[0] + 1 # add 1 year to expiry date     
            glist[1] = 12     
            glist[2] = 31     
            glist[3] = 23     
            glist[4] = 59     
            glist[5] = 59     
            glist[6] = 0     
            glist[7] = 365     
            glist[8] = 0     
            gtime = tuple(glist)     
            e = 'Friday, 31-Dec-99 23:59:59 GMT'     
            e = strftime('%A, %d-%b-%y %H:%M:%S GMT',gtime)     
            resp=REQUEST['RESPONSE']     
            author = quote(author)    
            resp.setCookie('_suggest_author',author,expires=e,path='/')     
            email = quote(email)    
            resp.setCookie('_suggest_email',email,expires=e,path='/')     
            resp.setCookie('suggest_notify',notify,expires=e,path='/')     
            if self.mod_comment:     
                p2 = "%s%s/%s/posting_html" % (self.absolute_url(),self.thread_path(),self.id)     
            else:     
                p2 = "%s%s/%s/%s/posting_html" % (self.absolute_url(),self.thread_path(),self.id,id)     
            return self.showMessage(self, REQUEST=REQUEST, title='Reply Posted',     
                                 message='Your reply has been posted',     
                                 action=p2     
                                )     
     
    # protected by 'Moderate Postings' permission
    def manage_edit(self,title,author,body,email='',notify='',reviewed='',     
                    REQUEST=None,RESPONSE=None,encoding='HTML'):     
        """ edit replies """     
    
        id = self.id     
        title = strip(title)     
        author = strip(author)     
        email = strip(email)     
    
        message=self.validateComment(REQUEST=REQUEST,title=title,author=author,    
                                     email=email,body=body,notify=notify,encoding=encoding)    
     
        if message:     
            return self.showError(self, REQUEST=REQUEST,title='Data Missing',     
                                 message=message,     
                                 action=REQUEST['URL1']+'/manage_editForm'     
                                )     
    
        body = split(CRLF.sub('\n',body),'\n')     

        # un-catalog this posting, getPhysicalPath should be acquired from this posting's SquishSite
        self.uncatalog_object(join(self.getPhysicalPath(),'/')+self.thread_path()+'/'+id)
                     
        self.title =title     
        self.author=author     
        self.email =email     
        self.body  =body     
        self.notify=notify
        self.encoding=encoding
     
        # re-catalog this posting, getPhysicalPath should be acquired from this posting's SquishSite
        self.catalog_object(self, join(self.getPhysicalPath(),'/')+self.thread_path()+'/'+id)
     
        if self.mod_comment and (not self.reviewed) and reviewed:     
            self.set_reviewed(self)
     
        if RESPONSE:     
            RESPONSE.redirect('%s/manage_postings' % self.absolute_url())     
     
    # Used to display the body of the posting with the appropriate formatting
    
    # protected by 'View' permission
    def showBody(self):
        return self.render(self.body,self.encoding)
     
Globals.default__class_init__(Posting)

class Article(Posting):     
    """ """

    __ac_permissions__ = (
        ('View', ['prev_item','next_item','showSummary','desc_items'], ('Anonymous', 'Manager')),
        )
    
    meta_type  ='Article'     
    icon   ='misc_/Squishdot/posting_img'     
    def __init__(self, id, thread, title, author, body,     
                 email, notify, reviewed, file, subject, dept, summary, encoding='HTML'):     
        Posting.__init__(self,id,thread,title,author,body,     
                 email, notify, reviewed, file, subject,0,encoding)     
        self.summary = summary     
        self.dept = dept     
             
    textToSearch__roles__=[]
    def textToSearch(self):
        # returns the text to search for a ZCatalog
        text=''
        try:
            for line in self.summary:
                # strip out HTML and append a newline to each line.
                text = text+tagRegex.sub("",line)+'\n'
        except TypeError:
            pass
        try:
            for line in self.body:
                # strip out HTML and append a newline to each line.
                text = text+tagRegex.sub("",line)+'\n'
        except TypeError:
            pass
        return text
    
    # protected by 'Moderate Postings' permission
    def manage_edit(self,title,author,body,email='',notify='',reviewed='', subject='', dept='', summary='',     
                    REQUEST=None,RESPONSE=None,encoding='HTML'):     
        """ edit an article """     
        title =strip(title)     
        author=strip(author)     
        email =strip(email)     
        subject =strip(subject)     
        dept =strip(dept)    
    
        message=self.validateArticle(REQUEST=REQUEST,title=title,author=author,    
                                     email=email,summary=summary,dept=dept,body=body,notify=notify,encoding=encoding)    
    
        if message:     
            return self.showError(self, REQUEST=REQUEST,title='Data Missing',     
                                 message=message,     
                                 action=REQUEST['URL1']+'/manage_editForm'     
                                )     
        id = self.id     
        body  =split(CRLF.sub('\n',body),'\n')     
        summary  =split(CRLF.sub('\n',summary),'\n')     
     
        # un-catalog this posting, getPhysicalPath should be acquired from this posting's SquishSite
        self.uncatalog_object(join(self.getPhysicalPath(),'/')+self.thread_path()+'/'+id)
     
        self.title =title     
        self.author=author     
        self.email =email     
        self.body  =body     
        self.summary  =summary     
        self.subject =subject     
        self.dept =dept     
        self.notify=notify
        self.encoding=encoding
     
        # re-catalog this posting, getPhysicalPath should be acquired from this posting's SquishSite
        self.catalog_object(self, join(self.getPhysicalPath(),'/')+self.thread_path()+'/'+id)
     
        if self.moderated and (not self.reviewed) and reviewed:     
            self.set_reviewed(self)
     
        if RESPONSE:     
            RESPONSE.redirect('%s/manage_postings' % self.absolute_url())     
     
    # protected by 'View' permission     
    def prev_item(self):     
        #""" return previous id in the item list"""     
        parent = self.site()[0]     
        currtime = int(time())     
        rlist = list(parent.id_list(currtime))     
        currpos = 0     
        try:     
            currpos = rlist.index(int(self.id))     
        except:     
            currpos = -1     
        if (currpos == 0) or (currpos < 0):     
            return None     
        else:     
            previd = rlist[currpos - 1]     
            obj = self.data[previd]     
            return (obj.__of__(self),)     
     
    # protected by 'View' permission
    def next_item(self):     
        #""" return next id in the item list """     
        parent = self.site()[0]     
        currtime = int(time())     
        rlist = list(parent.id_list(currtime))     
        currpos = 0     
        try:     
            currpos = rlist.index(int(self.id))     
        except:     
            currpos = -1     
        lastpos = len(rlist) - 1     
        if (currpos == lastpos) or (currpos < 0):     
            return None     
        else:     
            nextid = rlist[currpos + 1]     
            obj = self.data[nextid]     
            return (obj.__of__(self),)     
     
    # Used to display the summary of the article with the appropriate formatting
    
    # protected by 'View' permission
    def showSummary(self):
        return self.render(self.summary,self.encoding)
     
Globals.default__class_init__(Article)

class Comment(Posting):     
    """ """     
    meta_type  ='Comment'     
    icon       ='misc_/Squishdot/comment_img'     
     
Globals.default__class_init__(Comment)     
     
     
def manage_addSquishdot(self,id,title='',mailhost='',exp=0,expire='0',     
                              moderated=0, max_itemlist=30, default_doc='', mail_articles=0, mail_replies=0, REQUEST=None):     
    """Create Squishdot Site"""     
    if exp:     
        try:    expire=atoi(expire)     
        except: expire=0     
    else:   expire=0     
    if mailhost:     
        try:    v=getattr(self, mailhost)     
        except: return MessageDialog(title='Invalid Mail Host',     
                                     message='Cannot find the named mail host!',     
                                     action=REQUEST['URL1']+'/manage_main'     
                                    )     
    ob=SquishSite(id, title, mailhost, expire, moderated, max_itemlist, default_doc,mail_articles, mail_replies, parent=self)         
    self._setObject(id, ob)     
     
    if REQUEST: return self.manage_main(self,REQUEST,update_menu=1)  





